/* Copyright (c) 2007 ActiveState Software Inc.
   See the file LICENSE.txt for licensing information. */

/**
 * An extension to add dialog-based spellchecking of text parts of files.
 */

if (typeof(ko) == 'undefined') {
    var ko = {};
}
if (!('extensions' in ko)) {
    ko.extensions = {};
}
if (!('spellchecker' in ko.extensions)) {
    ko.extensions.spellchecker = {};
}

(function() {
// Set up a controller to make sure we do this only when there's a view

var _bundle = Components.classes["@mozilla.org/intl/stringbundle;1"].
                getService(Components.interfaces.nsIStringBundleService).
                createBundle("chrome://komodospellchecker/locale/spellcheck.properties");
var __SpellCheckController = null;

function SpellCheckController() {
    try {
        window.controllers.appendController(this);
        window.addEventListener("unload", this.destroy.bind(this), false);
    } catch(e) {
        ko.logging.getLogger('spellchecker').exception(e);
    }
}

// The following two lines ensure proper inheritance (see Flanagan, p. 144).
SpellCheckController.prototype = new xtk.Controller();
SpellCheckController.prototype.constructor = SpellCheckController;

SpellCheckController.prototype.destroy = function() {
    window.controllers.removeController(this);
}

SpellCheckController.prototype.is_cmd_checkSpelling_enabled = function() {
    return (ko.views.manager.currentView
            && ko.views.manager.currentView.languageObj != null);
}

SpellCheckController.prototype.do_cmd_checkSpelling = function() {
    var obj = {};
    try {
        obj.view = ko.views.manager.currentView;
        if (!obj.view || !obj.view.languageObj) {
            alert(_bundle.GetStringFromName("noCurrentDocumentToSpellcheck"));
            return;
        }
        obj.ko = ko;
    } catch(ex) {
        var message = _bundle.formatStringFromName("errorCouldNotFindDocument",
                                                   [ex], 1);
        alert(message);
        return;
    }
    window.openDialog("chrome://komodospellchecker/content/koSpellCheck.xul",
                      "spellchecker",
                      "chrome,modal,titlebar",
                      obj);
}

this.SpellCheckController_onload = function() {
    __SpellCheckController = new SpellCheckController();
    window.removeEventListener("load", this.SpellCheckController_onload, true);
}

}).apply(ko.extensions.spellchecker);
window.addEventListener("load", ko.extensions.spellchecker.SpellCheckController_onload, true);
